% B-spline Tutorial
% by Ashish Myles (marcianx@gmail.com)

% Compute the greville abscissae from the knot sequence
function grev = greville(knots, deg)

nk = length(knots);
nc = nk - deg - 1;

if (deg == 0)
    G = zeros(nc, nk);
    for i = 1:nc
        G(i,i:i+1) = 1/2;
    end
    grev = G * knots';
else
    G = zeros(nc, nk);
    for i = 1:nc
        G(i,i+1:i+deg) = 1/deg;
    end
    grev = G * knots';
end

